
C---------------------------------------------------------------------------

      subroutine conv_gauss (in,out,sigma,n,flag)
 
      real    in(n), out(n), gauss(1000), res(1000)
      real    sum, sigma
      integer n, nelm2, i, j, nc, nout
      logical flag

C 
C    Subroutine to convolve array "in" with a gaussian with width "sigma"
C    In case the flag is .true. this means we are convolving an error array
C    and we need to square everything before convolving and to take the
C    square root after convolution.
C
 
C ------------------------------------------------------------------------

      if (sigma .eq. 0.0) then
         do 100 i = 1,n
            out(i) = in(i)
 100     continue
         return
      end if
 
      nc = max( int(0.5*sigma), 5)
      nelm2 = 2*nc-1
 
      sum = 0.0
      do 200 i = 1,nelm2
         gauss(i) = exp(-0.5*((i-nc)/sigma)**2)
         sum = sum + gauss(i)
 200  continue
      do 300 i = 1, nelm2
         gauss(i) = gauss(i)/sum
 300  continue
 
      nout = n - nelm2 + 1
 
C ------------------------------------------------------------------------
C     Do the convolution

C   Flux Convolution
 
      if (.not. flag) then
         do 400 i = 1,nout
            sum = 0.0
            do 500 j = 1,nelm2
               sum = sum + in(i+j-1) * gauss(nelm2-j+1)
 500        continue
            res(i) = sum
 400     continue

C   Sigma Convolution

      else
         do 600 i = 1,nout
            sum = 0.0
            do 700 j = 1,nelm2
               sum = sum + in(i+j-1)**2 * gauss(nelm2-j+1)**2
 700        continue
            res(i) = sqrt(sum)
 600     continue
      end if
 
      do 800 i = 1,(nelm2-1)/2
         out(i) = in(i)
 800  continue
 
      do 900 i = 1,nout
         out((nelm2-1)/2+i) = res(i)
 900  continue
 
      do 1000 i = nout+1,n
         out(i) = in(i)
 1000 continue

      return
      end
