
C---------------------------------------------------------------------------

      subroutine lfit(x,y,sig,ndata,a,ma,lista,mfit,covar,ncvm,chisq)

C
C   General Linear Least Squares fit using Gauss-Jordan Elimination to
C   solve the normal linear equations of condition.   
C   Taken from Numerical Recipes (Price, Flannery, Teukolsky, & Vetterling)
C   Chapter 14.3
C
C   LFIT is not the best way to approach GLLS in general, but for this
C   application it seems to suffice.  
C
C   Modified for better error handling (replaced "pause" statements) and
C   made declarations more explicit  [RWP/OSU 1992 April 29]
C

      parameter (MMAX = 10)
      real x(ndata), y(ndata), sig(ndata), a(ma)
      real covar(ncvm,ncvm), beta(MMAX), afunc(MMAX)
      integer lista(mfit)
      
      kk = mfit + 1
      do 12 j = 1, ma
         ihit = 0
         do 11 k = 1, mfit
            if (lista(k) .eq. j) ihit = ihit + 1
 11      continue
         if (ihit .eq. 0) then
            lista(kk) = j
            kk = kk + 1
         else if (ihit .gt. 1) then
            print *,'LFIT: Improper Set in LISTA'
            print *,'Program Aborting'
            stop
         end if
 12   continue
      if (kk .ne. (ma + 1)) then
         print *,'LFIT: Improper Set in LISTA'
         print *,'Program Aborting'
         stop
      end if
      do 14 j = 1, mfit
         do 13 k = 1, mfit
            covar(j,k) = 0.
 13      continue
         beta(j) = 0.
 14   continue
      do 18 i = 1, ndata
         call funcs(x(i),afunc,ma)
         ym = y(i)
         if (mfit .lt. ma) then
            do 15 j = mfit + 1, ma
               ym = ym-a(lista(j))*afunc(lista(j))
 15         continue
         end if
         sig2i = 1./sig(i)**2
         do 17 j = 1, mfit
            wt = afunc(lista(j))*sig2i
            do 16 k = 1, j
               covar(j,k) = covar(j,k) + wt*afunc(lista(k))
 16         continue
            beta(j) = beta(j) + ym*wt
 17      continue
 18   continue
      if (mfit .gt. 1) then
         do 21 j = 2, mfit
            do 19 k = 1, j-1
               covar(k,j) = covar(j,k)
 19         continue
 21      continue
      end if
      call gaussj(covar,mfit,ncvm,beta,1,1)
      do 22 j = 1, mfit
         a(lista(j)) = beta(j)
 22   continue
      chisq = 0.
      do 24 i = 1, ndata
         call funcs(x(i),afunc,ma)
         sum = 0.
         do 23 j = 1, ma
            sum = sum + a(j)*afunc(j)
 23      continue
         chisq = chisq + ((y(i)-sum)/sig(i))**2
 24   continue
      call covsrt(covar,ncvm,ma,lista,mfit)
      return
      end
