
C---------------------------------------------------------------------------
 
      subroutine read_data (wave,flux_1,sigma_1,flux_2,sigma_2,n)
 
c     implicit         none
 
      real             wave(1),flux_1(1),flux_2(1)
      real             sigma_1(1),sigma_2(1)
      integer          n, NMAX, i, n1, n2
 
      character*40     infile
      
      logical          exist
 
      parameter        (NMAX=1024)
 
      real             wave_1(NMAX), wave_2(NMAX)

C-----------------------------------------------------------------------
C   Prompt for filename of first input file
 
 666  exist = .false.
 
      do while (.not.exist)
         write (6,'(" Enter name of first spectrum : ",$)')
         read (5,'(a)') infile
 
         inquire (file=infile,exist=exist)
         if (.not.exist) then
            write (5,*) ' '
            write (5,*) ' *** WARNING ***  File not found '
            write (5,*) ' '
         end if
      end do

      open(40, file=infile, status='old',iostat=ierr)
      if (ierr .ne. 0) then
         print *,'Cannot open file: ',infile
         print *,'Reason: IOSTAT=',ierr
         go to 666
      end if
      do 100 i = 1,NMAX
         read(40,*,end=1) wave_1(i),flux_1(i),sigma_1(i)
 100  continue
 1    n1 = i-1
      close(40)
 
C-----------------------------------------------------------------------
C   Prompt for filename of second input file
 
 667  exist = .false.
 
      do while (.not.exist)
         write (6,'(" Enter name of second spectrum : ",$)')
         read (5,'(a)') infile
         
         inquire (file=infile,exist=exist)
         if (.not.exist) then
            write (5,*) ' '
            write (5,*) ' *** WARNING ***  File not found '
            write (5,*) ' '
         end if
      end do
 
      open(40, file=infile, status='old', iostat=ierr)
      if (ierr .ne. 0) then
         print *,'Cannot open file: ',infile
         print *,'Reason: IOSTAT=',ierr
         go to 667
      end if
      do 200 i = 1,NMAX
         read(40,*,end=2) wave_2(i),flux_2(i),sigma_2(i)
 200  continue
 2    n2 = i-1
      close(40)
 
      if (n1 .ne. n2) then
         print *,'*** READ_DATA: FATAL ERROR ***'
         print *,'Files have different lengths!'
         stop
      end if
 
      n = n1
 
      do 300 i = 1, n
         wave(i) = wave_1(i)
         if (wave_1(i) .ne. wave_2(i)) then
            print *,'*** READ_DATA: FATAL ERROR! ***'
            print *,'Files have different wavelength scales!'
            stop
         end if
 300  continue
 
      return
      end
