
C---------------------------------------------------------------------------
      
      subroutine shift_spec(input,output,n,shift,sigma)
      
C  Shifts the input spectrum by "shift" pixels into the output spectrum
C  Shift not necessarily integer number
C  Note that a shift in a flux array is not the same as a shift in an
C  error array. In the latter case we need to propagate the errors of
C  the points used for the interpolation.
      
c     implicit         none
      integer          n,i,round
c      real             input(1),output(1),shift  <--- makes Sun f77 barf
      real             input(n),output(n),shift
      real             sign1,frac
      logical          sigma
      
      sign1 = sign(1.0,shift)

C  truncation; gives # pixels to hop over

      round = int(abs(shift)) 
      frac  = abs(shift) - round
      
C  flux shifting

      if (.not.sigma) then
         if (sign1 .gt. 0.0) then
            do 100 i = 1, n-round-1
               output(i) = (1.0-frac)*input(i+round) +
     &              frac*input(i+round+1)
 100        continue
            do 110 i = n-round, n
               output(i) = input(i)
 110        continue
         else
            do 120 i = round+2, n
               output(i) = (1.0-frac)*input(i-round) +
     &              frac*input(i-round-1)
 120        continue
            do 130 i = 1, round+1
               output(i) = input(i)
 130        continue
         end if

C  sigma shifting

      else
         if (sign1 .gt. 0.0) then
            do 200 i = 1, n-round-1
               output(i) =sqrt( ((1.0-frac)*input(i+round))**2 +
     &              (frac*input(i+round+1))**2 )
 200        continue
            do 210 i = n-round, n
               output(i) = input(i)
 210        continue
         else
            do 220 i = round+2, n
               output(i) =sqrt( ((1.0-frac)*input(i-round))**2 +
     &              (frac*input(i-round-1))**2 )
 220        continue
            do 230 i = 1, round+1
               output(i) = input(i)
 230        continue
         end if
      end if
      
      return
      end
