
C---------------------------------------------------------------------------
 
      subroutine wrout(wave,flux_1,sig_1,flux_2,sig_2,ntot,r,f,d)
 
      character*40     outfile
 
      logical          exist
 
      real wave(1)
      real flux_1(1), sig_1(1)
      real flux_2(1), sig_2(1)
      real r, f, d
 
      integer ntot,i,NMAX

C   Maximum spectral length 

      parameter (NMAX=1024)
 
      real work1(NMAX), work2(NMAX), work3(NMAX)
      real work4(NMAX), work5(NMAX), work6(NMAX)
 
C-----------------------------------------------------------------------
C   Prompt for filename of output file
 
      exist = .true.
 
      do while (exist)
         write (6,'(" Enter name of output spectrum file : ",$)')
         read (5,'(a)') outfile
 
         inquire (file=outfile,exist=exist)
         if (exist) then
            write (5,*) ' '
            write (5,*) ' *** WARNING ***  Already exists '
            write (5,*) ' '
         end if
      end do
 
C-----------------------------------------------------------------------
C   Shift second spectrum by 'd' pixels
 
      call shift_spec(flux_2,work1,ntot,d,.false.)
      call shift_spec(sig_2,work2,ntot,d,.true.)
 
C-----------------------------------------------------------------------
C   Scale second spectrum with flux factor 'r'

      do 100 i = 1, ntot
         work1(i) = r*work1(i)
         work2(i) = r*work2(i)
 100  continue
 
C-----------------------------------------------------------------------
 
C   Convolve (first/second) file with gaussian FWHM 'f' depending
C   whether f is (negative/positve)
 
      if (f .ge. 0.0) then
         call conv_gauss(work1,work3,f/2.35482,ntot,.false.)
         call conv_gauss(work2,work4,f/2.35482,ntot,.true.)
      else
         call conv_gauss(flux_1,work5,f/2.35482,ntot,.false.)
         call conv_gauss(sig_1,work6,f/2.35482,ntot,.true.)
         do 200 i = 1, ntot
            work3(i) = work1(i)
            work4(i) = work2(i)
 200     continue
      end if
 
C-----------------------------------------------------------------------
C   Open the output file
 
      open (38, file=outfile, recl=133, status='new',iostat=ierr)
      if (ierr .ne. 0) then
         print *,'Cannot open file: ',outfile
         print *,'Reason: IOSTAT=',ierr
         stop
      end if
         
      if (f.ge.0.0) then
         do 300 i = 1,ntot
            write(38,*) wave(i),work3(i),work4(i),work3(i),work1(i),
     &                  flux_1(i)-work3(i),flux_1(i)-work1(i)
 300     continue
      else
         do 310 i = 1,ntot
            write(38,*) wave(i),work3(i),work4(i),work5(i),flux_1(i),
     &                  work5(i)-work3(i),flux_1(i)-work3(i)
 310     continue
      end if

      close(38)
      return
      end
