
Flux scaling on input (read_data subroutine):
---------------------

1) add the "fsc" variable to the argument list of the data reading routine:

      subroutine rd_data2 (wave,flux_1,sigma_1,flux_2,sigma_2,fsc,n)
 
2) autoscaling routine

C  Autoscale the fluxes to of order unity based on the mean exponent of
C  the reference spectrum.   Remember the flux scaling factor for later
C  to rescale the output fluxes (wrout2.f) to the original flux scale.

      fsc = 0.0
      npts = 0
      do 400 i = 1, n
         farg = abs(flux_1(i))
         if (farg .ne. 0.0) then
            fsc = fsc + float(nint(log10(farg)))
            npts = npts + 1
         end if
 400  continue
      fsc = fsc / float(npts)
      if (abs(fsc) .lt. 3.) then
         fsc = 1.0
         return
      else
         ifsc = nint(fsc) - 1
         fsc = 10.0**(-ifsc)
      end if
      do 401 i = 1, n
         flux_1(i) = fsc*flux_1(i)
         sigma_1(i) = fsc*sigma_1(i)
         flux_2(i) = fsc*flux_2(i)
         sigma_2(i) = fsc*sigma_2(i)
 401  continue


Flux Scaling on output (wrout subroutine):
----------------------

1) add fsc to the argument list:

      subroutine wrout2(wave,flux_1,sig_1,flux_2,sig_2,ntot,r,f,d,fsc)

2) code to de-scale the fluxes on output:
 
C   Smooth the (Reference|Object) spectrum with a Gaussian of FWHM=F 
C   depending whether F is (Negative|Positve)
C
C   Array WORK3 will hold the (smoothed) Object spectrum fluxes
C   Array WORK4 will hold the (smoothed) Object spectrum sigmas
C   Array WORK5 will hold the (smoothed) Reference spectrum fluxes
C   Array WORK6 will hold the (smoothed) Reference spectrum sigmas
C
C   Remove the flux autoscaling at this time, too
C

      if (f .ge. 0.0) then
         call conv_gauss(work1,work3,f/2.35482,ntot,.false.)
         call conv_gauss(work2,work4,f/2.35482,ntot,.true.)
         do 200 i = 1, ntot
            work3(i) = work3(i)/fsc
            work4(i) = work4(i)/fsc
            work5(i) = flux_1(i)/fsc
            work6(i) = sig_1(i)/fsc
 200     continue
      else
         call conv_gauss(flux_1,work5,f/2.35482,ntot,.false.)
         call conv_gauss(sig_1,work6,f/2.35482,ntot,.true.)
         do 201 i = 1, ntot
            work3(i) = work1(i)/fsc
            work4(i) = work2(i)/fsc
            work5(i) = work5(i)/fsc
            work6(i) = work6(i)/fsc
 201     continue
      end if


