
C---------------------------------------------------------------------------

      subroutine gaussj(a,n,np,b,m,mp)

C
C   Gauss-Jordan Elimination Routine.  Taken from Numerical Recipes
C   (Price, Flannery, Teukolsky, & Vetterling) Chapter 2.1
C
C   Modified to better handle errors by replacing "pause" statements
C   with explicit crash message, and to make declarations more explicit
C   [RWP/OSU 1992 April 29]
C

      parameter (NMAX = 50)
      real    a(np,np),b(np,mp)
      integer ipiv(NMAX),indxr(NMAX),indxc(NMAX)

      do 11 j = 1, n
         ipiv(j) = 0
 11   continue
      do 22 i = 1, n
         big = 0.
         do 13 j = 1, n
            if (ipiv(j).ne.1) then
               do 12 k = 1, n
                  if (ipiv(k).eq.0) then
                     if (abs(a(j,k)).ge.big) then
                        big = abs(a(j,k))
                        irow = j
                        icol = k
                     end if
                  else if (ipiv(k).gt.1) then
                     print *, 'GAUSSJ: Singular Matrix'
                     print *, 'Program Aborting'
                     stop
                  end if
 12            continue
            end if
 13      continue
         ipiv(icol) = ipiv(icol)+1
         if (irow.ne.icol) then
            do 14 l = 1, n
               dum = a(irow,l)
               a(irow,l) = a(icol,l)
               a(icol,l) = dum
 14         continue
            do 15 l = 1, m
               dum = b(irow,l)
               b(irow,l) = b(icol,l)
               b(icol,l) = dum
 15         continue
         end if
         indxr(i) = irow
         indxc(i) = icol
         if (a(icol,icol) .eq. 0.) then
            print *,'GAUSSJ: Singular Matrix.'
            print *,'Program Aborting'
            stop
         end if
         pivinv = 1./a(icol,icol)
         a(icol,icol) = 1.
         do 16 l = 1, n
            a(icol,l) = a(icol,l)*pivinv
 16      continue
         do 17 l = 1, m
            b(icol,l) = b(icol,l)*pivinv
 17      continue
         do 21 ll = 1, n
            if (ll.ne.icol) then
               dum = a(ll,icol)
               a(ll,icol) = 0.
               do 18 l = 1, n
                  a(ll,l) = a(ll,l)-a(icol,l)*dum
 18            continue
               do 19 l = 1, m
                  b(ll,l) = b(ll,l)-b(icol,l)*dum
 19            continue
            end if
 21      continue
 22   continue
      do 24 l = n, 1, -1
         if (indxr(l).ne.indxc(l)) then
            do 23 k = 1, n
               dum = a(k,indxr(l))
               a(k,indxr(l)) = a(k,indxc(l))
               a(k,indxc(l)) = dum
 23         continue
         end if
 24   continue
      return
      end
